* ADD_SCRNS -- for adding screens from Dan Bricklin's Demo program to
* a dBASE database where they can be pulled out by a Clipper program.
* don't forget to link MEMO.LIB in with this, or else MEMOREAD() won't work.
* This program is pretty bare-bones, but demonstrates the procedures and
* error checking that are necessary.
*
* 1/21/88 Bob DuCharme, 55 St. Mark's Pl. #6, New York, NY 10003

SET CONFIRM ON
CLEAR
SET COLOR TO W+
@ 3,24 SAY 'Add Screens to Database'
SET COLOR TO W

YorN = .f.          && initialized for Yes/No questions
dbfile = space(8)

@ 5,10 SAY 'Enter name of data file to store screens in: ' GET dbfile
READ
IF .NOT. ( file(dbfile+'.DBF') .AND. file(dbfile+'.DBT') )
     YorN = .f.          && initialized for following question
     @ 7,10 SAY '&dbfile does not exist on this disk.  Create it? (Y/N)'GET YorN
     READ
     IF YorN
          IF .NOT. file('SCRNSTRU.DBF')
               ? 'The file SCRNSTRU.DBF must be present to create a new data '
               ?? 'screen file.'
               WAIT
               CLEAR
               QUIT
          ELSE
               SET SAFETY OFF      && in case either .DBF or .DBT already exists
               CREATE &dbfile FROM scrnstru
          ENDIF
     ELSE                && if user doesn't want to create a new screen file
          CLEAR
          QUIT
     ENDIF
ELSE                     && if .DBF and .DBT files exist OK
     USE &dbfile
ENDIF
IF RECCOUNT() > 0
     @ 9,10 SAY 'Do you want to see a list of the screens currently in &dbfile? ' GET YorN
     READ
     IF YorN
          counter = 1
          DO WHILE .NOT. EOF()
               ? scrname
               counter = counter + 1
               IF counter = 24
                    WAIT
                    counter = 1
               ENDIF
          SKIP
          ENDDO
          ? 'All done listing screens.'
          WAIT
     ENDIF
ENDIF

all_done = .f.
mscrname = space(8)
DO WHILE .NOT. all_done           && add the screens to the database
     CLEAR
     @ 5,10 SAY 'Enter screen name to add, or enter "quit": ' GET mscrname
     READ
     IF upper(mscrname) = 'QUIT'
          all_done = .t.
          LOOP
     ENDIF
     scrnfile = trim(upper(mscrname)) + '.TXT'
     IF .NOT. file(scrnfile)
          @ 7,10 SAY 'The file &scrnfile does not exist on this disk.'
          WAIT '        Press any key to continue . . . '
          LOOP
     ENDIF
     LOCATE FOR scrname = upper(mscrname)
     IF found()
         @ 7,10 SAY '&mscrname already exists in the &dbfile file.  Replace it?'
         @ 7,70 GET YorN
         READ
         IF .NOT. YorN
              LOOP
         ELSE        && it will just be replaced
            @ 9,10 SAY 'Remember, dBASE memo fields handle changes just by adding'
            @ 10,10 SAY 'the new version without deleting the old one, so your '
            @ 11,10 SAY 'DBT file can get really big after a couple of edits.  By'
            @ 12,10 SAY 'using the dBASE "COPY TO" command, and then erasing the '
            @ 13,10 SAY 'original and renaming the copy, you can bring it back '
            @ 14,10 SAY "down to it's real size."
         ENDIF
     ELSE                     && if not found, add blank for it
          APPEND BLANK
          REPLACE scrname WITH upper(mscrname)
     ENDIF
     * mscreen variable necessary because for some reason it doesn't work to say
     * REPLACE screen WITH memoread(scrnfile)
     mscreen = memoread(scrnfile)
     REPLACE screen WITH mscreen
     @ 16,10 SAY '&scrnfile has been added to &dbfile.'
     WAIT '         Press any key to continue . . . '
ENDDO
CLEAR
* EOF for ADD_SCRNS